\section{Conclusion}

The presented STF feature introduces an additional data access mode \stfSAME
that allows replicating data output. This access mode is provided
to the programmer to declare replicated data modifications across
ranges of nodes. 

The use of this access mode has been validated on a
2D 5-points stencil algorithm by implementing its
communication-avoiding variant. The resulting code is simplified by
using the access mode -- the programmer does not need to consider
additional tasks to explicitly manage replicated copies, rather they
just tell the runtime what tasks should be make redundant over which
ranks. The experimental results assess the effectiveness of this new
feature as the communication-avoiding variant proves to be more
scalable than its conventional counterpart, as expected from the
literature.

We have also leveraged this extension to express scalable variants of the
Cholesky decomposition where diagonal blocks factorization is replicated among
multiple ranks. These algorithms also lead us to propose a preliminary
implementation of an allreduce generic subgraph submission routine inside of the
StarPU runtime system. We compared our implementation against state-of-the-art
ConfCHOX Cholesky decomposition and found that are approaches scale were
competitive on relatively small problems up to 256 compute nodes.
%We have also presented an extension to leverage all-reduce reduction pattern.
%Albeit not dynamically detected by the runtime system, such patterns
%have been implemented in a generic fashion to benefit a wide variety of
%algorithms. We have compared our STF implementation of the Cholesky
%decomposition using a replicating mechanism with state-of-the-art implementation
%relying on MPI+X. On very small problems that make the communication volume
%salient,
%we have found moderate improvement from the replicating mechanism. While our STF
%approach tend to scale over larger node counts than the MPI+X approach, the
%difference in scalability between the most simple variant -- a 2D algorithm -- and our most
%sophisticated variant -- a 3D algorithm with replication -- only serves to show
%that the latter is operational and marginally competitive. Additional work will
%be dedicated to benchmark our approach over GPU where the relative computing
%power is expected to stress the communication network to the point that
%mechanisms such as replication will provide strong scalability for larger, more practical
%problems.

%The data write replication mechanism presented in this paper is motivated by
%scalable algorithms in general. Scalable linear algebra algorithms also exhibit
%such mechanisms to trade-off computational load with cost of the communications
%over the critical path. These tradeoffs have been theoretically and practically
%studied in the case of dense factorizations~\cite{s.d:11,g.g.s.z:12} as well as
%sparse symmetric factorization~\cite{j.z.n.y:16}.
%However the communication-avoiding
%variant of LU and Cholesky factorizations have often been implemented using
%synchronous MPI+X approaches. Such an approach fails to provide a portable
%expression that would be enabled by general-purpose runtime systems. In future
%works, we will study scalable factorization algorithms as their expression
%should prove compact and productive through late extensions in programming
%models such as STF.

\section*{Acknowledgements}

We would like to thank the member of the StarPU development team for their
insightful discussions. This work has been funded by the SOLHARIS ANR project
(ANR-19-CE46-0009). This work was granted access to the HPC resources of CEA
under the allocation A0110605063.

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "submission"
%%% jinx-languages: "en"
%%% End:
